package com.its.op.service.its.scrs;

import com.its.op.dao.repository.its.scrs.TbScIxrCmraMngmRepository;
import com.its.op.dto.its.scrs.TbScIxrCmraMngmDto;
import com.its.op.entity.its.scrs.TbScIxrCmraMngm;
import com.its.op.entity.its.scrs.TbScIxrCmraMngmKey;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbScIxrCmraMngmService {

    private final TbScIxrCmraMngmRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbScIxrCmraMngm requireOne(TbScIxrCmraMngmKey ixrId) throws NoSuchElementException {
        Optional<TbScIxrCmraMngm> info = this.repo.findById(ixrId);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + ixrId);
        }
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbScIxrCmraMngmDto> findAll() {
        List<TbScIxrCmraMngmDto> result = new ArrayList<>();
        List<TbScIxrCmraMngm> data = this.repo.findAll();
        for (TbScIxrCmraMngm entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbScIxrCmraMngmDto> findAllList() {
        List<TbScIxrCmraMngmDto> result = new ArrayList<>();
        List<TbScIxrCmraMngm> data = this.repo.findAllList();
        for (TbScIxrCmraMngm entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbScIxrCmraMngmDto findById(TbScIxrCmraMngmKey ixrId) {
        TbScIxrCmraMngm entity = requireOne(ixrId);
        return entity.toDto();
    }

    // 데이터 변경
    @Transactional
    public TbScIxrCmraMngmDto updateById(TbScIxrCmraMngmKey ixrId, TbScIxrCmraMngmDto.TbScIxrCmraMngmUpdReq req) {
        TbScIxrCmraMngm entity = requireOne(ixrId);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbScIxrCmraMngmDto> mergeInfoList(List<TbScIxrCmraMngmDto.TbScIxrCmraMngmUpdReq> reqList) {
        List<TbScIxrCmraMngmDto> result = new ArrayList<>();
        for (TbScIxrCmraMngmDto.TbScIxrCmraMngmUpdReq req : reqList) {
            TbScIxrCmraMngm obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbScIxrCmraMngmDto mergeInfo(TbScIxrCmraMngmDto.TbScIxrCmraMngmUpdReq req) {
        TbScIxrCmraMngm obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbScIxrCmraMngmDto deleteById(TbScIxrCmraMngmKey ixrId) {
        TbScIxrCmraMngm entity = requireOne(ixrId);
        this.repo.deleteById(ixrId);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbScIxrCmraMngmDto> deleteByIds(List<TbScIxrCmraMngmKey> ids) {
        List<TbScIxrCmraMngmDto> result = new ArrayList<>();
        for (TbScIxrCmraMngmKey id : ids) {
            Optional<TbScIxrCmraMngm> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

}
